summaryrefslogtreecommitdiff
path: root/eclass/tests/tests-common.sh
diff options
context:
space:
mode:
authorV3n3RiX <venerix@redcorelinux.org>2017-10-09 18:53:29 +0100
committerV3n3RiX <venerix@redcorelinux.org>2017-10-09 18:53:29 +0100
commit4f2d7949f03e1c198bc888f2d05f421d35c57e21 (patch)
treeba5f07bf3f9d22d82e54a462313f5d244036c768 /eclass/tests/tests-common.sh
reinit the tree, so we can have metadata
Diffstat (limited to 'eclass/tests/tests-common.sh')
-rw-r--r--eclass/tests/tests-common.sh105
1 files changed, 105 insertions, 0 deletions
diff --git a/eclass/tests/tests-common.sh b/eclass/tests/tests-common.sh
new file mode 100644
index 000000000000..d52cf3a2687b
--- /dev/null
+++ b/eclass/tests/tests-common.sh
@@ -0,0 +1,105 @@
+#!/bin/bash
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+if ! source /lib/gentoo/functions.sh ; then
+ echo "Missing functions.sh. Please install sys-apps/gentoo-functions!" 1>&2
+ exit 1
+fi
+
+# Let overlays override this so they can add their own testsuites.
+TESTS_ECLASS_SEARCH_PATHS=( .. )
+
+inherit() {
+ local e path
+ for e in "$@" ; do
+ for path in "${TESTS_ECLASS_SEARCH_PATHS[@]}" ; do
+ local eclass=${path}/${e}.eclass
+ if [[ -e "${eclass}" ]] ; then
+ source "${eclass}"
+ continue 2
+ fi
+ done
+ die "could not find ${e}.eclass"
+ done
+}
+EXPORT_FUNCTIONS() { :; }
+
+debug-print() {
+ [[ ${#} -eq 0 ]] && return
+
+ if [[ ${ECLASS_DEBUG_OUTPUT} == on ]]; then
+ printf 'debug: %s\n' "${@}" >&2
+ elif [[ -n ${ECLASS_DEBUG_OUTPUT} ]]; then
+ printf 'debug: %s\n' "${@}" >> "${ECLASS_DEBUG_OUTPUT}"
+ fi
+}
+
+debug-print-function() {
+ debug-print "${1}, parameters: ${*:2}"
+}
+
+debug-print-section() {
+ debug-print "now in section ${*}"
+}
+
+has() {
+ local needle=$1
+ shift
+
+ local x
+ for x in "$@"; do
+ [ "${x}" = "${needle}" ] && return 0
+ done
+ return 1
+}
+use() { has "$1" ${IUSE} ; }
+
+die() {
+ echo "die: $*" 1>&2
+ exit 1
+}
+
+has_version() {
+ portageq has_version / "$@"
+}
+
+tret=0
+tbegin() {
+ ebegin "Testing $*"
+}
+texit() {
+ rm -rf "${tmpdir}"
+ exit ${tret}
+}
+tend() {
+ t eend "$@"
+}
+t() {
+ "$@"
+ local ret=$?
+ : $(( tret |= ${ret} ))
+ return ${ret}
+}
+
+tmpdir="${PWD}/tmp"
+pkg_root="${tmpdir}/$0/${RANDOM}"
+T="${pkg_root}/temp"
+D="${pkg_root}/image"
+WORKDIR="${pkg_root}/work"
+ED=${D}
+mkdir -p "${D}" "${T}" "${WORKDIR}"
+
+dodir() {
+ mkdir -p "${@/#/${ED}/}"
+}
+
+elog() { einfo "$@" ; }
+
+IUSE=""
+CATEGORY="dev-eclass"
+PN="tests"
+PV="0"
+P="${PN}-${PV}"
+PF=${P}
+SLOT=0